diff --git a/src/tgp.cpp b/src/tgp.cpp
--- a/src/tgp.cpp
+++ b/src/tgp.cpp
@@ -17,6 +17,8 @@
 #include "core/alloc_func.hpp"
 #include "core/random_func.hpp"
 #include "landscape_type.h"
+#include "tgp.h"
+#include "debug.h"
 
 /*
  *
@@ -201,34 +203,77 @@
 /** Walk through all items of _height_map.h */
 #define FOR_ALL_TILES_IN_HEIGHT(h) for (h = _height_map.h; h < &_height_map.h[_height_map.total_size]; h++)
 
-/** Maximum index into array of noise amplitudes */
-static const int TGP_FREQUENCY_MAX = 6;
+/**
+ * Noise amplitudes(multiplied by 1024).
+ * - indexed by "smoothness setting" and log2(frequency).
+ *
+ * @note TGP_FREQUENCY_MAX + 1 values as the first value is the scale.
+ * @see HeightMapGenerate()
+ */
+static const amplitude_t _amplitudes_by_smoothness_and_frequency[7][TGP_FREQUENCY_MAX + 1] = {
+	/* lowest frequency....  ...highest (every corner) */
+	/* Very smooth */
+	{ 2143, 27832, 51429, 51657, 41657, 51429, 1597, 233, 37, 16},   // backup good one except mountainous 2048 * 2048
+	/* Smooth */
+	{ 6448, 911, 27832, 31131, 16511, 1427, 1597, 233, 29, 8},       // test reduce peaks
+	/* Rough */
+	{17657, 29832, 36832, 51429, 16511, 51429, 233, 1597, 1301, 16}, // backup good one except mountainous 2048 * 2048
+	/* Very Rough */
+	{17657, 6448, 36832, 51429, 16511, 17657, 233, 1597, 1301, 16},  // backup good one except mountainous 2048 * 2048
+	/* Cereally rough -bonus- */
+	{ 17657, 31832, 39832, 29832, 16511, 43429, 233, 2597, 37, 16},  // test reduce peaks
+	/* CommutorZ -bonus- */
+	{25000, 10000, 8000, 24000, 12000, 2500, 250, 100, 80, 25},      // backup good one. all mapsizes. No islands.
+	/* Go with the flow -bonus- */
+	{13511, 22739, 51429, 253, 421, 21131, 137, 7, 37, 261}          // backup good one. all mapsizes. No islands.
+};
 
 /**
- * Noise amplitudes (multiplied by 1024)
- * - indexed by "smoothness setting" and log2(frequency)
+ * Array holding some extra smoothing parameters that are applied after _amplitudes_and_frequency.
+ * They represent in order of appearance :
+ * { smoothing radius, power of smoothing (1= smoothest, 10 = almost unsmoothed), min. smoothing step size }
+ *
+ * @see Smooth()
  */
-static const amplitude_t _amplitudes_by_smoothness_and_frequency[4][TGP_FREQUENCY_MAX + 1] = {
-	/* lowest frequncy....  ...highest (every corner) */
-	/* Very smooth */
-	{16000,  5600,  1968,   688,   240,    16,    16},
-	/* Smooth */
-	{16000, 16000,  6448,  3200,  1024,   128,    16},
-	/* Rough */
-	{16000, 19200, 12800,  8000,  3200,   256,    64},
-	/* Very Rough */
-	{24000, 16000, 19200, 16000,  8000,   512,   320},
+static const int _smoothing_parameters[7][3] = {
+	{3, 3, 8}, ///< Very  smooth
+	{4, 3, 8}, ///< Smooth
+	{2, 7, 8}, ///< Rough
+	{2, 4, 8}, ///< Very rough
+	{2, 5, 8}, ///< Cereally rough - bonus -
+	{2, 6, 8}, ///< CommutorZ - bonus -
+	{2, 5, 4}  ///< Go with the flow - bonus -
 };
 
 /** Desired water percentage (100% == 1024) - indexed by _settings_game.difficulty.quantity_sea_lakes */
-static const amplitude_t _water_percent[4] = {20, 80, 250, 400};
+static const amplitude_t _water_percent[4] = {70, 170, 270, 420};
 
-/** Desired maximum height - indexed by _settings_game.difficulty.terrain_type */
-static const int8 _max_height[4] = {
-	6,       ///< Very flat
-	9,       ///< Flat
-	12,      ///< Hilly
-	15       ///< Mountainous
+/**
+ * Desired maximum height - indexed by _settings_game.difficulty.terrain_type and the map size.
+ *
+ * Sense of indexing by mapsize too:
+ * Below, h_max_new is calculated as min(map_size_x, map_size_y) / the constant defined here.
+ * Later, for calculating the height of some individual tile, the formula:
+ *  h_max_new * (h - h_waterlevel) / (h_max - h_waterlevel), where h_max is the maximal heightlevel
+ * existing anywhere on the map at the time of that computation step.
+ * So, to summarize:
+ * For mapsize 64x64, the above division gives 1. And, h - h_waterlevel is always
+ * smaller than h_max - h_waterlevel. So, the result is a map consisting just of water
+ * - i.e. at heightlevel 0 :-/.
+ * My conclusion was:
+ * Indexing this setting by the mapsize is a good thing, as one gains much more
+ * control on the heightlevel distribution of maps now and small maps work at all.
+ * The n-th value of the second component is for log(min(map_size_x, map_size_y)) - 6, so
+ * index 0 is for map size 64, whereas index 8 is for map size 8192.
+ */
+static const int _max_height[7][9] = {
+	{32, 48, 72, 170, 340, 680, 1360, 2720, 5440}, ///< Fallen... cant get up
+	{21, 40, 50,  64, 128, 380,  760, 1520, 3040}, ///< Very flat
+	{16, 27, 38,  51, 102, 204,  408,  916, 1832}, ///< Flat
+	{12, 21, 30,  39,  60, 120,  240,  480,  960}, ///< Bumpy
+	{10, 13, 17,  20,  33,  66,  132,  264,  528}, ///< Hilly
+	{9,  10, 11,  12,  13,  24,   48,   96,  192}, ///< Mountainous
+	{5,   6,  7,   7,   7,  12,   24,   48,   96}  ///< Alpinist
 };
 
 /**
@@ -242,7 +287,6 @@
 	return ((int)x) >= 0 && x < _height_map.size_x && ((int)y) >= 0 && y < _height_map.size_y;
 }
 
-
 /**
  * Allocate array of (MapSizeX()+1)*(MapSizeY()+1) heights and init the _height_map structure members
  * @return true on success
@@ -308,8 +352,11 @@
 static bool ApplyNoise(uint log_frequency, amplitude_t amplitude)
 {
 	uint size_min = min(_height_map.size_x, _height_map.size_y);
-	uint step = size_min >> log_frequency;
-	uint x, y;
+	int step = size_min >> log_frequency;
+	int x, y;
+
+	height_t* temp_height_map;
+	temp_height_map = CallocT<height_t>(_height_map.total_size);
 
 	/* Trying to apply noise to uninitialized height map */
 	assert(_height_map.h != NULL);
@@ -319,8 +366,8 @@
 
 	if (log_frequency == 0) {
 		/* This is first round, we need to establish base heights with step = size_min */
-		for (y = 0; y <= _height_map.size_y; y += step) {
-			for (x = 0; x <= _height_map.size_x; x += step) {
+		for (y = 0; y <= (int)_height_map.size_y; y += step) {
+			for (x = 0; x <= (int)_height_map.size_x; x += step) {
 				height_t height = (amplitude > 0) ? RandomHeight(amplitude) : 0;
 				_height_map.height(x, y) = height;
 			}
@@ -330,8 +377,8 @@
 
 	/* It is regular iteration round.
 	 * Interpolate height values at odd x, even y tiles */
-	for (y = 0; y <= _height_map.size_y; y += 2 * step) {
-		for (x = 0; x < _height_map.size_x; x += 2 * step) {
+	for (y = 0; y <= (int)_height_map.size_y; y += 2 * step) {
+		for (x = 0; x < (int)_height_map.size_x; x += 2 * step) {
 			height_t h00 = _height_map.height(x + 0 * step, y);
 			height_t h02 = _height_map.height(x + 2 * step, y);
 			height_t h01 = (h00 + h02) / 2;
@@ -340,8 +387,8 @@
 	}
 
 	/* Interpolate height values at odd y tiles */
-	for (y = 0; y < _height_map.size_y; y += 2 * step) {
-		for (x = 0; x <= _height_map.size_x; x += step) {
+	for (y = 0; y < (int)_height_map.size_y; y += 2 * step) {
+		for (x = 0; x <= (int)_height_map.size_x; x += step) {
 			height_t h00 = _height_map.height(x, y + 0 * step);
 			height_t h20 = _height_map.height(x, y + 2 * step);
 			height_t h10 = (h00 + h20) / 2;
@@ -350,8 +397,8 @@
 	}
 
 	/* Add noise for next higher frequency (smaller steps) */
-	for (y = 0; y <= _height_map.size_y; y += step) {
-		for (x = 0; x <= _height_map.size_x; x += step) {
+	for (y = 0; y <= (int)_height_map.size_y; y += step) {
+		for (x = 0; x <= (int)_height_map.size_x; x += step) {
 			_height_map.height(x, y) += RandomHeight(amplitude);
 		}
 	}
@@ -359,6 +406,60 @@
 	return (step > 1);
 }
 
+/**
+ * This function prevents inverted pyramids on map generation by applying some extra smoothing.
+ *
+ * @param log_frequency what round of mapgeneration are we in?
+ * @param radius   The radius to use for the extra smoothing.
+ * @param weakness The strongness / weakness  for the extra smoothing.
+ * @param min_step The step in tiles before I apply the extra smoothing again.
+ * @see HeightMapGenerate()
+ */
+void Smooth(uint log_frequency, int radius, int weakness, int min_step)
+{
+	uint size_min = min(_height_map.size_x, _height_map.size_y);
+	int step = size_min >> log_frequency;
+
+	if(step < min_step) {
+		return;
+	} else {
+		if(step < min_step * 2) {
+			weakness += 4;
+		}
+	}
+
+	height_t* temp_height_map;
+	temp_height_map = CallocT<height_t>(_height_map.total_size);
+
+	for (uint y = 0; y <= _height_map.size_y; y += step) {
+		for (uint x = 0; x <= _height_map.size_x; x += step) {
+			temp_height_map[x + y * _height_map.size_x] = _height_map.height(x, y);
+		}
+	}
+
+	for (uint y = 0; y <= _height_map.size_y; y += step) {
+		for (uint x = 0; x <= _height_map.size_x; x += step) {
+			height_t current = temp_height_map[x + y * _height_map.size_x];
+			int sum = current * 100 * weakness;
+			int weights = 100 * weakness; // the inmost tile has the highest weight
+
+			for(int i = -radius; i <= radius; i++){
+				for(int j = -radius; j <= radius; j++){
+					if((i != 0 || j != 0) && x + i * step <= _height_map.size_x
+							&& x + i * step > 0 && y + j * step <= _height_map.size_y
+							&& y + j * step > 0) {
+						int square = (int) sqrt((double)(i * i + j * j));
+						sum += temp_height_map[x + i * step + (y + j * step) * _height_map.size_x] * 100 / square;
+						weights += 100 / square;
+					}
+				}
+			}
+
+			_height_map.height(x, y) = sum / weights;
+		}
+	}
+}
+
 /** Base Perlin noise generator - fills height map with raw Perlin noise */
 static void HeightMapGenerate()
 {
@@ -379,6 +480,7 @@
 	/* Keep increasing the frequency until we reach the step size equal to one tile */
 	do {
 		log_frequency = iteration_round - log_frequency_min;
+
 		if (log_frequency >= 0) {
 			/* Apply noise for the next frequency */
 			assert(log_frequency <= TGP_FREQUENCY_MAX);
@@ -387,10 +489,26 @@
 			/* Amplitude for the low frequencies on big maps is 0, i.e. initialise with zero height */
 			amplitude = 0;
 		}
+
 		continue_iteration = ApplyNoise(iteration_round, amplitude);
+
+		if(amplitude > 0) {
+			/* Apply some extra parameters to prevent inverted pyramids. */
+			Smooth(iteration_round, _smoothing_parameters[_settings_game.game_creation.tgen_smoothness][0],
+					_smoothing_parameters[_settings_game.game_creation.tgen_smoothness][1],
+					_smoothing_parameters[_settings_game.game_creation.tgen_smoothness][2]);
+		}
+
 		iteration_round++;
+
 	} while (continue_iteration);
-	assert(log_frequency == TGP_FREQUENCY_MAX);
+
+	assert(log_frequency <= TGP_FREQUENCY_MAX);
+
+	if (log_frequency != TGP_FREQUENCY_MAX) {
+		DEBUG(map, 0, "Frequency wrong: log_frequency = %i, TGP_FREQUENCY_MAX = %i",
+				log_frequency, TGP_FREQUENCY_MAX);
+	}
 }
 
 /** Returns min, max and average height from height map */
@@ -434,6 +552,12 @@
 /** Applies sine wave redistribution onto height map */
 static void HeightMapSineTransform(height_t h_min, height_t h_max)
 {
+	if ((_settings_game.game_creation.tgen_smoothness == SMOOTHNESS_VERY_ROUGH)
+			|| (_settings_game.game_creation.tgen_smoothness == SMOOTHNESS_CEREALLY_ROUGH)) {
+		/* Make the map really rough for very rough and cereally rough settings, skip this function. */
+		return;
+	}
+
 	height_t *h;
 
 	FOR_ALL_TILES_IN_HEIGHT(h) {
@@ -447,12 +571,14 @@
 		switch (_settings_game.game_creation.landscape) {
 			case LT_TOYLAND:
 			case LT_TEMPERATE:
-				/* Move and scale 0..1 into -1..+1 */
-				fheight = 2 * fheight - 1;
-				/* Sine transform */
-				fheight = sin(fheight * M_PI_2);
-				/* Transform it back from -1..1 into 0..1 space */
-				fheight = 0.5 * (fheight + 1);
+				{
+					/* Move and scale 0..1 into -1..+1 */
+					fheight = 2 * fheight - 1;
+					/* Sine transform */
+					fheight = sin(fheight * M_PI_2);
+					/* Transform it back from -1..1 into 0..1 space */
+					fheight = 0.5 * (fheight + 1);
+				}
 				break;
 
 			case LT_ARCTIC:
@@ -643,6 +769,61 @@
 	}
 }
 
+/* TODO:
+ * Temp solution for applying curves with the more heightlevels patch enabled.
+ * 1 / 2
+ * Cut untill End when fixed.
+ */
+
+/**
+ * Applies variation to the map if AllowMoreHeightlevels() is true and the variety setting is not set to none.
+ *
+ * @note for the moment there is only one variation for all settings
+ * @note It would be nice to have a few more variation options if AllowMoreHeigtlevels() is true.
+ */
+struct MHScontrol_point_t {
+	height_t x;
+	height_t y;
+};
+
+static const MHScontrol_point_t _curve_map[] = {
+	{ 0, 0 }, { 48, 48 }, { 96, 72 }, { 160, 128 }, { 192, 160 }, { 240, 255}, { 255, 255 }
+};
+
+static void MHSHeightMapCurves()
+{
+	height_t h_min, h_max, h_avg, h_diff;
+	HeightMapGetMinMaxAvg(&h_min, &h_max, &h_avg);
+	h_diff = h_max - h_min;
+
+	/* "Normalize" the control points to the height map data */
+	MHScontrol_point_t *cm = MallocT<MHScontrol_point_t>(lengthof(_curve_map));
+	for (uint i = 0; i < lengthof(_curve_map); i++) {
+		cm[i].x = _curve_map[i].x * h_diff / 255 + h_min;
+		cm[i].y = _curve_map[i].y * h_diff / 255 + h_min;
+	}
+
+	/* Apply curve */
+	height_t *h;
+	FOR_ALL_TILES_IN_HEIGHT(h) {
+		for (uint i = 0; i < lengthof(_curve_map) - 1; i++) {
+			MHScontrol_point_t &p1 = cm[i];
+			MHScontrol_point_t &p2 = cm[i + 1];
+
+			if (*h >= p1.x && *h <= p2.x) {
+				*h = p1.y + (*h - p1.x) * (p2.y - p1.y) / (p2.x - p1.x);
+				break;
+			}
+		}
+	}
+
+	free(cm);
+}
+/*
+ * End temp solution for applying curves with the more heightlevels patch enabled.
+ * 1 / 2
+ */
+
 /** Adjusts heights in height map to contain required amount of water tiles */
 static void HeightMapAdjustWaterLevel(amplitude_t water_percent, height_t h_max_new)
 {
@@ -670,8 +851,8 @@
 	/* We now have the proper water level value.
 	 * Transform the height map into new (normalized) height map:
 	 *   values from range: h_min..h_water_level will become negative so it will be clamped to 0
-	 *   values from range: h_water_level..h_max are transformed into 0..h_max_new
-	 *   where h_max_new is 4, 8, 12 or 16 depending on terrain type (very flat, flat, hilly, mountains)
+	 *   values from range: h_water_level..h_max are transformed into 0..h_max_new,
+	 *   where h_max_new is dependant on _settings_game.difficulty.terrain_type. (_max_height)
 	 */
 	FOR_ALL_TILES_IN_HEIGHT(h) {
 		/* Transform height from range h_water_level..h_max into 0..h_max_new range */
@@ -705,6 +886,8 @@
  *
  * Please note that all the small numbers; 53, 101, 167, etc. are small primes
  * to help give the perlin noise a bit more of a random feel.
+ *
+ * @note This function shapes map border coasts.
  */
 static void HeightMapCoastLines(uint8 water_borders)
 {
@@ -719,7 +902,7 @@
 		if (HasBit(water_borders, BORDER_NE)) {
 			/* Top right */
 			max_x = abs((perlin_coast_noise_2D(_height_map.size_y - y, y, 0.9, 53) + 0.25) * 5 + (perlin_coast_noise_2D(y, y, 0.35, 179) + 1) * 12);
-			max_x = max((smallest_size * smallest_size / 16) + max_x, (smallest_size * smallest_size / 16) + margin - max_x);
+			max_x = max((smallest_size * smallest_size / 64) + max_x, (smallest_size * smallest_size / 64) + margin - max_x);
 			if (smallest_size < 8 && max_x > 5) max_x /= 1.5;
 			for (x = 0; x < max_x; x++) {
 				_height_map.height(x, y) = 0;
@@ -729,7 +912,7 @@
 		if (HasBit(water_borders, BORDER_SW)) {
 			/* Bottom left */
 			max_x = abs((perlin_coast_noise_2D(_height_map.size_y - y, y, 0.85, 101) + 0.3) * 6 + (perlin_coast_noise_2D(y, y, 0.45,  67) + 0.75) * 8);
-			max_x = max((smallest_size * smallest_size / 16) + max_x, (smallest_size * smallest_size / 16) + margin - max_x);
+			max_x = max((smallest_size * smallest_size / 64) + max_x, (smallest_size * smallest_size / 64) + margin - max_x);
 			if (smallest_size < 8 && max_x > 5) max_x /= 1.5;
 			for (x = _height_map.size_x; x > (_height_map.size_x - 1 - max_x); x--) {
 				_height_map.height(x, y) = 0;
@@ -742,7 +925,7 @@
 		if (HasBit(water_borders, BORDER_NW)) {
 			/* Top left */
 			max_y = abs((perlin_coast_noise_2D(x, _height_map.size_y / 2, 0.9, 167) + 0.4) * 5 + (perlin_coast_noise_2D(x, _height_map.size_y / 3, 0.4, 211) + 0.7) * 9);
-			max_y = max((smallest_size * smallest_size / 16) + max_y, (smallest_size * smallest_size / 16) + margin - max_y);
+			max_y = max((smallest_size * smallest_size / 64) + max_y, (smallest_size * smallest_size / 64) + margin - max_y);
 			if (smallest_size < 8 && max_y > 5) max_y /= 1.5;
 			for (y = 0; y < max_y; y++) {
 				_height_map.height(x, y) = 0;
@@ -752,7 +935,7 @@
 		if (HasBit(water_borders, BORDER_SE)) {
 			/* Bottom right */
 			max_y = abs((perlin_coast_noise_2D(x, _height_map.size_y / 3, 0.85, 71) + 0.25) * 6 + (perlin_coast_noise_2D(x, _height_map.size_y / 3, 0.35, 193) + 0.75) * 12);
-			max_y = max((smallest_size * smallest_size / 16) + max_y, (smallest_size * smallest_size / 16) + margin - max_y);
+			max_y = max((smallest_size * smallest_size / 64) + max_y, (smallest_size * smallest_size / 64) + margin - max_y);
 			if (smallest_size < 8 && max_y > 5) max_y /= 1.5;
 			for (y = _height_map.size_y; y > (_height_map.size_y - 1 - max_y); y--) {
 				_height_map.height(x, y) = 0;
@@ -761,9 +944,19 @@
 	}
 }
 
-/** Start at given point, move in given direction, find and Smooth coast in that direction */
+/**
+ * Start at given point, move in given direction, find and Smooth coast in that direction
+ *
+ * @note This function shapes normal map coasts.
+ */
 static void HeightMapSmoothCoastInDirection(int org_x, int org_y, int dir_x, int dir_y)
 {
+	if ((_settings_game.game_creation.tgen_smoothness == SMOOTHNESS_VERY_ROUGH)
+			|| (_settings_game.game_creation.tgen_smoothness == SMOOTHNESS_CEREALLY_ROUGH)) {
+		/* Make the map really rough for very rough and cereally rough settings, skip this function. */
+		return;
+	}
+
 	const int max_coast_dist_from_edge = 35;
 	const int max_coast_Smooth_depth = 35;
 
@@ -771,7 +964,7 @@
 	int ed; // coast distance from edge
 	int depth;
 
-	height_t h_prev = 16;
+	height_t h_prev = min(_height_map.size_x + 1, _height_map.size_y + 1) / TGP_HEIGHT_FACTOR;
 	height_t h;
 
 	assert(IsValidXY(org_x, org_y));
@@ -779,7 +972,7 @@
 	/* Search for the coast (first non-water tile) */
 	for (x = org_x, y = org_y, ed = 0; IsValidXY(x, y) && ed < max_coast_dist_from_edge; x += dir_x, y += dir_y, ed++) {
 		/* Coast found? */
-		if (_height_map.height(x, y) > 15) break;
+		if (_height_map.height(x, y) > (int)(min(_height_map.size_x + 1, _height_map.size_y + 1) / TGP_HEIGHT_FACTOR - 1)) break;
 
 		/* Coast found in the neighborhood? */
 		if (IsValidXY(x + dir_y, y + dir_x) && _height_map.height(x + dir_y, y + dir_x) > 0) break;
@@ -839,6 +1032,21 @@
 }
 
 /**
+ * Gets the maximum allowed height while generating a map
+ * based on mapsize, terrain_type and the setting to allow moreheightlevels.
+ */
+static int TGPGetMaxAllowedHeight()
+{
+	/* Subtract 6 because the value for map size 64 = 2^6
+	 * is stored at index 0 in the array.
+	 * @See discussion at the definition of _max_height */
+	const int map_size_index_in_mh = min(MapLogX(), MapLogY()) - 6;
+	const int mh = _max_height[_settings_game.difficulty.terrain_type][map_size_index_in_mh];
+	const int retValue = I2H(min((min(_height_map.size_x + 1, _height_map.size_y + 1)) / mh, GetMaxTileHeight()));
+	return retValue;
+}
+
+/**
  * Height map terraform post processing:
  *  - water level adjusting
  *  - coast Smoothing
@@ -849,7 +1057,7 @@
 {
 	int sea_level_setting = _settings_game.difficulty.quantity_sea_lakes;
 	const amplitude_t water_percent = sea_level_setting != (int)CUSTOM_SEA_LEVEL_NUMBER_DIFFICULTY ? _water_percent[sea_level_setting] : _settings_game.game_creation.custom_sea_level * 1024 / 100;
-	const height_t h_max_new = I2H(_max_height[_settings_game.difficulty.terrain_type]);
+	const height_t h_max_new = TGPGetMaxAllowedHeight() + 1;
 	const height_t roughness = 7 + 3 * _settings_game.game_creation.tgen_smoothness;
 
 	HeightMapAdjustWaterLevel(water_percent, h_max_new);
@@ -865,10 +1073,27 @@
 
 	HeightMapSineTransform(12, h_max_new);
 
-	if (_settings_game.game_creation.variety > 0) {
+/* TODO:
+ * Temp solution for applying curves with the more heightlevels patch enabled.
+ * 2 / 2
+ * Revert to code below, untill End when fixed.
+//	if (_settings_game.game_creation.variety > 0) {
+//		HeightMapCurves(_settings_game.game_creation.variety);
+//	}
+ */
+	if ((_settings_game.game_creation.variety > 0) && (!AllowMoreHeightlevels()) && (_settings_game.game_creation.landscape == 1)) {
 		HeightMapCurves(_settings_game.game_creation.variety);
 	}
 
+	if ((_settings_game.game_creation.variety > 0) && (AllowMoreHeightlevels()) && (_settings_game.game_creation.landscape == 1)) {
+		MHSHeightMapCurves();
+	}
+
+/* TODO:
+ * End temp solution for applying curves with the more heightlevels patch enabled.
+ * 2 / 2
+ */
+
 	HeightMapSmoothSlopes(16);
 }
 
@@ -985,12 +1210,25 @@
 		for (x = 0; x < _height_map.size_x;     x++) MakeVoid(x);
 	}
 
+	const int mh = H2I(TGPGetMaxAllowedHeight());
+
 	/* Transfer height map into OTTD map */
 	for (y = 0; y < _height_map.size_y; y++) {
 		for (x = 0; x < _height_map.size_x; x++) {
 			int height = H2I(_height_map.height(x, y));
-			if (height < 0) height = 0;
-			if (height > 15) height = 15;
+
+			if (height < 0) {
+				height = 0;
+			}
+
+			if (height > mh - 1) {
+				height = mh - 1;
+			}
+
+			if (height > (int)GetMaxTileHeight()) {
+				height = GetMaxTileHeight();
+			}
+
 			TgenSetTileHeight(TileXY(x, y), height);
 		}
 	}
diff --git a/src/tgp.h b/src/tgp.h
--- a/src/tgp.h
+++ b/src/tgp.h
@@ -12,6 +12,21 @@
 #ifndef TGP_H
 #define TGP_H
 
+static const uint TGP_HEIGHT_FACTOR = 8;
+
+/** Maximum index into array of noise amplitudes. */
+static const int TGP_FREQUENCY_MAX = 9;
+
+enum Smoothness {
+	SMOOTHNESS_VERY_SMOOTH      = 0,
+	SMOOTHNESS_SMOOTH           = 1,
+	SMOOTHNESS_ROUGH            = 2,
+	SMOOTHNESS_VERY_ROUGH       = 3,
+	SMOOTHNESS_CEREALLY_ROUGH   = 4,
+	SMOOTHNESS_COMMUTORZ        = 5,
+	SMOOTHNESS_GO_WITH_THE_FLOW = 6,
+};
+
 void GenerateTerrainPerlin();
 
 #endif /* TGP_H */
diff --git a/src/tile_map.cpp b/src/tile_map.cpp
--- a/src/tile_map.cpp
+++ b/src/tile_map.cpp
@@ -12,8 +12,46 @@
 #include "stdafx.h"
 #include "tile_map.h"
 
+static Slope GetTileSlopeGivenHeight(uint hnorth, uint hwest, uint heast, uint hsouth, uint *h) {
+
+	/* Due to the fact that tiles must connect with each other without leaving gaps, the
+	 * biggest difference in height between any corner and 'min' is between 0, 1, or 2.
+	 *
+	 * Also, there is at most 1 corner with height difference of 2. */
+
+	uint hminnw = min(hnorth, hwest);
+	uint hmines = min(heast, hsouth);
+	uint hmin = min(hminnw, hmines);
+
+	uint hmaxnw = max(hnorth, hwest);
+	uint hmaxes = max(heast, hsouth);
+	uint hmax = max(hmaxnw, hmaxes);
+
+	uint r = SLOPE_FLAT; ///< Computed slope of the tile.
+
+	if (hnorth != hmin) {
+		r += SLOPE_N;
+	}
+	if (hwest != hmin) {
+		r += SLOPE_W;
+	}
+	if (heast != hmin) {
+		r += SLOPE_E;
+	}
+	if (hsouth != hmin) {
+		r += SLOPE_S;
+	}
+	if (hmax - hmin == 2) {
+		r += SLOPE_STEEP;
+	}
+
+	if (h != NULL) *h = hmin * TILE_HEIGHT;
+
+	return (Slope)r;
+}
+
 /**
- * Return the slope of a given tile
+ * Return the slope of a given tile inside the map.
  * @param tile Tile to compute slope of
  * @param h    If not \c NULL, pointer to storage of z height
  * @return Slope of the tile, except for the HALFTILE part
@@ -92,3 +130,21 @@
 
 	return h;
 }
+
+/**
+ * Get top height of the tile the outside map.
+ *
+ * @see Detailed description in header.
+ *
+ * @param tile Tile outside to compute height of.
+ * @return Maximum height of the tile.
+ */
+uint GetTileMaxZOutsideMap(int x, int y)
+{
+	uint h = TileHeightOutsideMap(x, y);
+	h = max(h, TileHeightOutsideMap(x + 1, y));
+	h = max(h, TileHeightOutsideMap(x, y + 1));
+	h = max(h, TileHeightOutsideMap(x + 1, y + 1));
+
+	return h * TILE_HEIGHT;
+}
diff --git a/src/tile_map.h b/src/tile_map.h
--- a/src/tile_map.h
+++ b/src/tile_map.h
@@ -15,40 +15,159 @@
 #include "slope_type.h"
 #include "map_func.h"
 #include "core/bitmath_func.hpp"
+#include "core/math_func.hpp"
 #include "settings_type.h"
 
 /**
- * Returns the height of a tile
+ * Returns wether more than 16 height levels are allowed.
+ * Basically, this returns the setting of the configuration variable
+ * allow_more_heightlevels.
+ * To avoid having to change multiple occurrences of the config variable
+ * in case some additional condition would get necessary,
+ * I introduced this function.
  *
- * This function returns the height of the northern corner of a tile.
+ * @return wether more than 16 height levels are allowed, based on allow_more_heightlevels and game mode.
+ */
+static inline bool AllowMoreHeightlevels()
+{
+	return _settings_game.construction.allow_more_heightlevels;
+}
+
+/**
+ * Returns the maximum heightlevel of a tile based on AllowMoreHeightlevels().
+ * This deduplicates a few if else statements in the code therefore it is usefull to have it here.
+ *
+ *@return MAX_TILE_HEIGHT_EXTENDED or MAX_TILE_HEIGHT_OLD based on AllowMoreHeightlevels().
+ */
+static inline uint GetMaxTileHeight()
+{
+	if (AllowMoreHeightlevels()) {
+		return MAX_TILE_HEIGHT_EXTENDED;
+	} else {
+		return MAX_TILE_HEIGHT_OLD;
+	}
+}
+
+/**
+ * Returns the maximum snowline height based on AllowMoreHeightlevels().
+ * This deduplicates a few if else statements in the code therefore it is usefull to have it here.
+ *
+ * @return MAX_SNOWLINE_HEIGHT_EXTENDED or MAX_SNOWLINE_HEIGHT_OLD based on AllowMoreHeightlevels(). 
+ */
+static inline uint GetMaxSnowlineHeight()
+{
+	if (AllowMoreHeightlevels()) {
+		return MAX_SNOWLINE_HEIGHT_EXTENDED;
+	} else {
+		return MAX_SNOWLINE_HEIGHT_OLD;
+	}
+}
+
+/**
+ * This function returns the maximum treeline height based on AllowMoreHeightlevels().
+ * This deduplicates a few if else statements in the code therefore it is usefull to have it here.
+ *
+ * @return MAX_TREELINE_HEIGHT_EXTENDED or MAX_TREELINE_HEIGHT_OLD based on AllowMoreHeightlevels().
+ */
+static inline uint GetMaxTreelineHeight()
+{
+	if (AllowMoreHeightlevels()) {
+		return MAX_TREELINE_HEIGHT_EXTENDED;
+	} else {
+		return MAX_TREELINE_HEIGHT_OLD;
+	}
+}
+
+/**
+ * This function returns the height of the northern corner of a tile based on AllowMoreHeightlevels().
  * This is saved in the global map-array. It does not take affect by
  * any slope-data of the tile.
  *
- * @param tile The tile to get the height from
- * @return the height of the tile
+ * @param tile The tile to get the height from.
+ * @return the height of the tile.
  * @pre tile < MapSize()
  */
 static inline uint TileHeight(TileIndex tile)
 {
 	assert(tile < MapSize());
-	return GB(_m[tile].type_height, 0, 4);
+
+	if (AllowMoreHeightlevels()) {
+		return _map_heightdata[tile].heightlevel;
+	} else {
+		return GB(_m[tile].type_height, 0, 4);
+	}
 }
 
 /**
- * Sets the height of a tile.
- *
- * This function sets the height of the northern corner of a tile.
+ * For a detailed description why we need this see discussion in
+ * GetTileMaxZOutsideMap in map_func.h.
+ */
+static inline uint TileHeightOutsideMap(int x, int y)
+{
+	/* In all cases: Descend to heightlevel 0 as fast as possible.
+	 * So: If we are at the 0-side of the map (x<0 or y<0), we must
+	 * subtract the distance to coordinate 0 from the heightlevel.
+	 * In other words: Subtract e.g. -x. If we are at the MapMax
+	 * side of the map, we also need to subtract the distance to
+	 * the edge of map, e.g. MapMaxX - x.
+	 *
+	 * NOTE: Assuming constant heightlevel outside map would be
+	 * simpler here. However, then we run into painting problems,
+	 * since whenever a heightlevel change at the map border occurs,
+	 * we would need to repaint anything outside map.
+	 * In contrast, by doing it this way, we can localize this change,
+	 * which means we may assume constant heightlevel for all tiles
+	 * at more than <heightlevel at map border> distance from the
+	 * map border. */
+	if (x < 0) {
+		if (y < 0) {
+			return max((int)TileHeight(TileXY(0, 0)) - (-x) - (-y), 0);
+		} else if (y < (int)MapMaxY()) {
+			return max((int)TileHeight(TileXY(0, y)) - (-x), 0);
+		} else {
+			return max((int)TileHeight(TileXY(0, (int)MapMaxY())) - (-x) - (y - (int)MapMaxY()), 0);
+		}
+	} else if (x < (int)MapMaxX()) {
+		if (y < 0) {
+			return max((int)TileHeight(TileXY(x, 0)) - (-y), 0);
+		} else if (y < (int)MapMaxY()) {
+			return TileHeight(TileXY(x, y));
+		} else {
+			return max((int)TileHeight(TileXY(x, (int)MapMaxY())) - (y - (int)MapMaxY()), 0);
+		}
+	} else {
+		if (y < 0) {
+			return max((int)TileHeight(TileXY((int)MapMaxX(), 0)) - (x - (int)MapMaxX()) - (-y), 0);
+		} else if (y < (int)MapMaxY()) {
+			return max((int)TileHeight(TileXY((int)MapMaxX(), y)) - (x - (int)MapMaxX()), 0);
+		} else {
+			return max((int)TileHeight(TileXY((int)MapMaxX(), (int)MapMaxY())) - (x - (int)MapMaxX()) - (y - (int)MapMaxY()), 0);
+		}
+	}
+}
+
+/**
+ * This function sets the height of the northern corner of a tile based on AllowMoreHeightlevels().
  *
  * @param tile The tile to change the height
  * @param height The new height value of the tile
  * @pre tile < MapSize()
- * @pre heigth <= MAX_TILE_HEIGHT
+ * @pre heigth <= GetMaxTileHeight()
  */
 static inline void SetTileHeight(TileIndex tile, uint height)
 {
 	assert(tile < MapSize());
-	assert(height <= MAX_TILE_HEIGHT);
-	SB(_m[tile].type_height, 0, 4, height);
+
+	if (height > GetMaxTileHeight()) {
+		/* Make sure height is within allowed range. */
+		height = GetMaxTileHeight();
+	}
+
+	if (AllowMoreHeightlevels()) {
+		_map_heightdata[tile].heightlevel = height;
+	} else {
+		SB(_m[tile].type_height, 0, 4, height);
+	}
 }
 
 /**
